;;; cl-scopes/test/test-storage

;;;; testing facility for scopes/storage

(defpackage :scopes/test-storage
  (:use :common-lisp)
  (:local-nicknames (:storage :scopes/storage)
                    (:tracking :scopes/storage/tracking) 
                    (:t :scopes/testing))
  (:export #:*db-config-postgres* #:*db-config-sqlite*
           #:run #:run-all #:run-postgres #:run-sqlite)
  (:import-from :scopes/testing #:==))

(in-package :scopes/test-storage)

(defparameter *db-config-sqlite* nil)
(defparameter *db-config-postgres* nil)
(load "test/etc")

(defun run-all ()
  (run-sqlite)
  (run-postgres))

(defun run-sqlite ()
  (let ((storage:*db-config* *db-config-sqlite*))
    (run)))

(defun run-postgres ()
  (let ((storage:*db-config* *db-config-postgres*))
    (run)))

(defun run ()
  (let* ((storage:*db-engine* (storage:make-engine))
         (st (storage:make-storage))
         (t:*tst* (t:test-suite)))
    (test-track st)
    (t:show-result)))

(defun test-track (st)
  (let ((tr (make-instance 'tracking:track)))
    (storage:drop-table st :tracks)
    (tracking:create-table st :tracks '(taskid username))
    (== (tracking:data tr) nil)))
